{*****************************************************************************}
{*									     *}
{*				    BrickOut				     *}
{*			     by George Petrov /YGP/			     *}
{*		   (c) 1990, Software R&D Laboratory, Sofia		     *}
{*									     *}
{*****************************************************************************}

{ $define Demo} 				       { 樮  }
								      {$R-,I-}
program {$ifdef Demo} BrickD {$else} BrickOut {$endif} (message);
  uses (*) UniCRT{*) DOS, CRT, UniPascal {*};

  const HghScrName = 'BrickOut.HGH';                 {   䠩  窨 }

	ClickLng   = 10;
	WallClick  = 23;
	PadClick   = 25;
	BrickClick = 28;

	Xsize = 40;	       {   ᪠  X (⥫ ࠬ) }
	Ysize = 22;	       {   ᪠  Y (⥫ ࠬ) }

	Nwalls =     7; 			     { ன ⥭窨  嫨 }
	WallXbeg =  19; 			    { ꤥ 碠 ⥭ }
	WallDist =   3; 			{ ࠧﭨ  ⥭窨 }

	EntryX = 18;		  { X,Y न  ꤥ  ᪠ ⮯ }
	EntryY = Ysize div 2;

	StartBalls = 5; 		  {   ⮯  碠  }
	MaxPadSz   = 7; 					  {$ifdef Demo}
	MinPadSz   = 1; 						{$else}
	MinPadSz   = 3; 					       {$endif}

	PadSpeed = (*)	3 {*)  10 {*};				  {$ifdef Demo}
	MaxSpeed = (*)	1 {*)	1 {*};					{$else}
	MaxSpeed = (*)	5 {*)  30 {*};				       {$endif}
	LargeStep = (*) 4 {*)	7 {*};
	MinSpeed = (*) 10 {*)  50 {*};
	SmallStep = (*) 1 {*)	3 {*};

	WallCh	   (*){*): string[2] {*} = '';
	BrickCh    (*){*): string[2] {*} = '';
	BallCh	   (*) = #27#7{*): string[2] = 'o' {*};
	EmptyCh    (*){*): string[2] {*} = ' ';
	PadCh	   (*){*): string[2] {*} = '';
	PadEndCh   (*){*): string[2] {*} = '';

	WallClr    = (*)$71{*) $17{*};	     { White on blue Border (default) }
	OBrickClr  = (*)$61{*) $16{*};
	EBrickClr  = (*)$51{*) $15{*};
	EmptyClr   = (*)$71{*) $17{*};
	BallClr    = (*)$71{*) $17{*};			 { White on blue Ball }
	PadClr	   = (*)$21{*) $12{*};				  { Green Pad }
	NormalText = (*)$71{*) $17{*};			 { White on blue text }

	LeftKey  = (*)#$c1{*)#75{*};
	RightKey = (*)#$c2{*)#77{*};
	DownKey  = (*)#$c3{*)#80{*};
	UpKey	 = (*)#$c4{*)#72{*};
	ESCkey	 = #27;

  type HighScore = record
	 Name:	  string[13]; Rnd1: Cardinal;		{ 砩 ᫠  }
	 Score:   LongInt;    Rnd2: Cardinal;		 {  㤠  ࠣ }
	 Level:   Natural;    Rnd3: Cardinal;
	 Date:	  Cardinal;   Rnd4: Cardinal;
	 Time:	  Cardinal;   Rnd5: Cardinal;
	 CheckSum: Cardinal;  Rnd6: Cardinal;
       end; { HighScore }

       ba = packed array [0..100] of byte;

  var LevelNo: natural; 				   { current Level No }
      Nballs:  natural; 			       {     }
      Nbricks: natural; 			    {  嫨 ⠢  }
      Xball,					    { X, Y   ⮯ }
      Yball,
      Xb, Yb,
      PadSize,						{    }
      Ypad:    natural; 			     { ୨ ࠩ   }
      dxBall,				    { ᮪     ⮯ }
      dyBall,
      dyPad:   integer; 		    { ᮪      }
      pWait,
      Wait,
      Pspeed:  natural;
      Speed:   natural;
      PntsPerWall: natural;

      Score:   LongInt; 		      {  窨 祭   }


      Crash: boolean;
      NoErrors: boolean;		   {   ࠢ   誠 }

      Bricks:	 array [0..Xsize-1] of set of 2..Ysize-1;
      BrickPnts: array [0..Xsize-1] of natural;

      PlayerName: string[13];				      { Player's name }

      HasntHigh: boolean;
      Position: integer;
      HS: array [1..16] of HighScore;

{$ifNdef UniPas}

  var SaveCH: byte;
      hascolor,
      not_40: boolean;
      SaveMode: byte;
      p50: dirStr;
      n50: NameStr;
      e50: ExtStr;

  procedure GotoXY(X, Y: byte);
  begin
  if not_40 then x:= x + x - 1;
  CRT.GotoXY(x, y);
  end; { GotoXY }

  procedure Cursor(visible: boolean);
    var r: registers;
  begin
  r.AH:= $03; r.BH:= 0; { Get cursor size }
  intr($10, r);
  r.AH:= 01; { Set CursorSize }
  if visible
    then r.CH:= SaveCH
    else begin SaveCh:= r.ch; r.CH:= $20; end;
  intr($10, r);
  end; { Cursor }

  procedure TextCo40;
    var r: registers;
  begin
  r.AH:= $0f; intr($10, r); SaveMode:= r.AL;
  case r.AL of
    0, 1: { OK };
    2, 3: r.AL:= r.AL -2;   { make 0/1 }
    4, 5: r.AL:= 5 - r.AL; { --- " --- }
    7: ;
    else r.AL:= 1;
    end; { case }

  hascolor:= r.AL = 1;
  TextMode(r.AL);
  r.AH:= $0f; intr($10, r);
  not_40:= r.AH <> 40;
  end; { TextCo40 }

  procedure ReturnMode;
    var r: registers;
  begin
  r.AH:= 0; r.AL:= SaveMode;
  intr($10, r);
  r.AH:= $0f; intr($10, r);
  not_40:= r.AH <> 40;
  end; { ReturnMode }

  procedure SetColor(clr: byte);
  begin
  if hascolor { color monitor }
    then begin CRT.TextColor(clr and $f);
	 Crt.TextBackground(clr div 16);
	 end;
  end; { SetColor }

  procedure PlayNote(Note, tembr: byte; length: word);
  begin
  Sound(Note);
  Delay(round(length*1.536));
  NoSound;
  end { PlayeNote };

{$endif}

  procedure ShowTop;
    var i, j: integer;
	cs: cardinal;
	bap: ^ba;

    procedure WriteDateTime;
      var day, month, year: natural;
	  w, hour, min: natural;
    begin
    hour:= HS[i].Time div 60;
    min:= HS[i].Time mod 60;
    w:= HS[i].date;
    day:=   w mod 32; w:= w div 32;
    month:= w mod 16; w:= w div 16;
    year:=  w + 80;

    if day <> 0
      then begin write(hour: 3, ':');
	   if min < 10 then write('0');
	   write(min);
	   write(day:3, '.');
	   if month < 10 then write('0');
	   write(month, '.');
	   write(year);
	   end
      else write('': 3 + 1 + 2 + 3 + 1 + 2 + 1 + 2);
    end; { WriteDateTime }

    label Again;
    var f: file;
	wrks: string;

  begin { ShowTop }
  writeln('  - ⨦': 37);
  writeln('No            窨     ');
	  { 1. ............ ..... 33 14:32 11.12.89}
  for i:= 1 to 16 do
    begin write(i: 2, '. ');
Again:
    if HS[i].level <> 0
      then begin
	   cs:= 0; bap:= addr(HS[i]);
	   for j:= 0 to SizeOf(HS[i])-1 do
	     inc(cs, bap^[j]);
	   dec(cs, cardinal(Hi(HS[i].CheckSum)) +cardinal(Lo(HS[i].CheckSum)));

	   if cs <> HS[i].CheckSum
	     then begin (*) MoveWords(HS[i+1],HS[i],WordSizeOf(HS[1])*(16-i));
		  {*) Move(HS[i+1], HS[i], SizeOf(HS[i])*(16-i)); {*}

		  (*) FillWord(HS[16], WordSizeOf(HS[16]), 0);
		  {*) FillChar(HS[16], SizeOf(HS[16]), #0); {*}

		  (*) rewrite(f, HghScrName);
		  {*) Fsplit(SYSTEM.ParamStr(0), p50, n50, e50);
		      (*$ifdef IN_IDE*) p50:= ''; (*$endif*)
		      assign(f, p50+HghScrName); rewrite(f, 1); {*}

		  BlockWrite(f, HS, SizeOf(HS));
		  close(f);
		  goto Again;
		  end
	     else begin
		  if HS[i].Score < 100000
		    then begin
			 write(HS[i].name (*): -13{*),
			       '': 13 - length(HS[i].name){*});
			 write(HS[i].Score: 5, HS[i].Level: 3);
			 end
		    else begin wrks:= HS[i].name;
			 if 10 < length(wrks) then wrks[0]:= #10;
			 write(wrks(*): -10{*),'': 10 - length(wrks){*});
			 write(HS[i].Score: 8, HS[i].Level: 3);
			 end;
		  WriteDateTime;
		  end;
	   end(*); {*) else if not not_40 then writeln; {*}
    (*){*)if not_40 then {*} writeln;
    end;
  end; { ShowTop }

  procedure ReadHighScores;
    var i: integer;
	f: file of HighScore;
  begin
  (*) reset(f, HghScrName);
  {*) Fsplit(SYSTEM.ParamStr(0), p50, n50, e50);
      (*$ifdef IN_IDE*) p50:= ''; (*$endif*)
      assign(f, p50+HghScrName); reset(f); {*}
  if HasntHigh
    then (*) FillWord(HS, WordSizeOf(hs), 0);
	 {*) FillChar(HS, SizeOf(hs), 0); {*}

  i:= 1;
  while (IOresult = 0) and (i <= 16) do
    begin read(f, HS[i]); inc(i); end;

  HasntHigh:= false;
  (*){*) Close(f); if IOresult <> 0 then; {*}
  end; { ReadHighScores }

  procedure DoubleLine;
    var i: integer;
  begin
  for i:= 1 to 40 do write('');
  (*){*) if not_40 then {*} writeln;
  end; { DoubleLine }

  procedure Title;
  begin
  ClrScr;						       { Clear Screen }
  writeln('嫨  ⥭': 28);
  writeln('(c) 1990  "ணࠬ ᨣ"': 38);
  writeln(' 1.00': 25);
  DoubleLine;
  end; { Title }

  procedure GetName;
  begin
  (*){*)Cursor(true);{*}

  {$ifdef Demo}
    write('! ᭥ .');
    if (readkey = #0) (*){*) and (readkey = #0) {*} then ;
  {$else}
    write(', ꢥ  : ');
    readln(PlayerName);
    while (PlayerName <> '') and (PlayerName[length(PlayerName)] = ' ') do
      delete(PlayerName, length(PlayerName), 1);
  {$endif}

  (*){*)Cursor(false);{*}
  end; { GetName }

  procedure WriteStatus;
    {$ifNdef UniPas}
    procedure gotoxy(x, y: byte);
    begin
    CRT.GOTOXY(x, y);
    end;
    {$endif}
  begin
  SetColor(NormalText);
  GotoXY( 9, 23); write(Nballs: 5);
  GotoXY( 9, 24); write(Score: 5);
  GotoXY( 9, 25); write(HS[1].score: 5);
  SetColor(BallClr);
  end; { WriteStatus }

  procedure DrawBoard;
    var y, x: integer;
	nw, bclr: shortcard;
  begin
  SetColor(WallClr); clrscr;
  for x:= 0 to Xsize - 1 do
    begin Bricks[x]:= []; BrickPnts[x]:= 0; end;
  GotoXY(1,	1); for x:= 1 to Xsize do write(WallCh);
  GotoXY(1, Ysize); for x:= 1 to Xsize do write(WallCh);
  bclr:= OBrickClr; Nbricks:= 0;
  for y:= 2 to Ysize-1 do
    begin x:= WallXbeg; nw:= 0;
    repeat GotoXY(x, y); SetColor(bclr);
      write(BrickCh); inc(Nbricks);
      (*) incl(Bricks[x], y); {*) Bricks[x]:= Bricks[x] + [y]; {*}
      bclr:= ObrickClr + EBrickClr - bclr;
      inc(nw); BrickPnts[x]:= nw * PntsPerWall;
      inc(x, WallDist);
    until nw = Nwalls;
    GotoXY(Xsize, y); SetColor(WallClr); Write(WallCh);
    end;
  SetColor(NormalText);
  GotoXY(WallXbeg - WallDist + 1, Ysize+1);
  for x:= WallXbeg to WallXbeg + (Nwalls -1) * WallDist do
    if BrickPnts[x] <> 0 then write(BrickPnts[x]: WallDist);
  GotoXY(1, 23); write(' ⮯:');
  GotoXY(1, 24); write(' 窨:');
  GotoXY(1, 25); write('४:');
  SetColor(BallClr);
  end; { DrawBoard }

  procedure MoveBall;
    var NewX, NewY, Xpos, Ypos: integer;
  begin
  NewX:= Xball + dxBall; NewY:= Yball + dyBall;
  Xpos:= (NewX + 5) div 10; Ypos:= (NewY +5) div 10;

  if Ypos <= 1
    then begin PlayNote(WallClick, 1, ClickLng); dyBall:= - dyBall;
	 NewY:= 40 - NewY; Ypos:= (NewY + 5) div 10;
	 end;
  if Ysize <= Ypos
    then begin PlayNote(WallClick, 1, ClickLng); dyBall:= - dyBall;
	 NewY:= 20 * (Ysize-1) - NewY; Ypos:= (NewY + 5) div 10;
	 end;
  if Xsize <= Xpos
    then begin PlayNote(WallClick, 1, ClickLng); dxBall:= - dxBall;
	 NewX:= 20 * (Xsize-1) - NewX; Xpos:= (NewX + 5) div 10;
	 if random(3) = 0 then inc(dyBall, 1 - random(3));
	 if abs(dyBall) > 10 then
	   if dyBall < 0
	     then dyBall:= -10
	     else dyBall:= 10;
	 end;

  if Xpos < 1
    then begin Crash:= true; (*) return {*) exit {*}; end;
  if Xpos = 1
    then if (Ypos < Ypad) or (Ypad+PadSize <= Ypos) {    }
	   then begin {      㢠 }
		{     ᫥ 室 }
		end
	   else begin PlayNote(PadClick, 1, ClickLng); dxBall:= - dxBall;
		NewX:= 40 - NewX; Xpos:= (NewX + 5) div 10;
		if odd(PadSize)
		  then if Ypos <> Ypad + PadSize div 2
			 then dec(dyBall, Ypad +PadSize div 2 -Ypos)
			 else inc(dyBall, (1 - random(3)) * ord(random(3) = 0))
		  else dec(dyBall, Ypad +PadSize div 2 -Ypos -
				   ord(Ypad + PadSize div 2 <= Ypos));
		if abs(dyBall) > 10 then
		  if dyBall < 0
		    then dyBall:= -10
		    else dyBall:= 10;
		{$ifNdef Demo}

		if dyPad <> 0 then
		  if (dyPad * dyBall) > 0
		    then begin
			 if speed < MinSpeed
			   then if pSpeed = PadSpeed
				  then inc(speed, LargeStep)
				  else inc(speed, SmallStep);
			 end
		    else begin
			 if MaxSpeed < Speed
			   then if pSpeed = PadSpeed
				  then dec(speed, LargeStep)
				  else dec(speed, SmallStep);
			 end;
		{$endif}

		end;

  if Ypos in Bricks[Xpos]
    then begin PlayNote(BrickClick+(Xpos-WallXbeg) div WallDist, 1, ClickLng);
	 (*) excl(Bricks[Xpos], Ypos);
	 {*) Bricks[Xpos]:= Bricks[Xpos] - [Ypos]; {*}
	 GotoXY(Xpos, Ypos); SetColor(EmptyClr); write(EmptyCh);
	 dec(Nbricks); inc(Score, BrickPnts[Xpos]);
	 SetColor(NormalText);
	 GotoXY( 9, 24); write(Score: 5);
	 if dxBall < 0
	   then begin
		if random(7) <> 0  { ࠦ }
		  then begin dxBall:= - dxBall;
		       NewX:= 20 * (Xpos + 1) - NewX;
		       Xpos:= (NewX + 5) div 10;
		       end
		end
	   else begin dxBall:= - dxBall;
		NewX:= 20 * (Xpos - 1) - NewX; Xpos:= (NewX + 5) div 10;
		end;
	 if random(11) <= 2
	   then inc(dyBall, 1 - random(3));
	 end;

  GotoXY(Xb, Yb); SetColor(EmptyClr); write(EmptyCh);
  SetColor(BallClr);
  Xball:= NewX; Yball:= NewY; Xb:= Xpos; Yb:= Ypos;
  GotoXY(Xpos, Ypos); write(BallCh);
  end { MoveBall };

  procedure MovePad;
  begin
  if dyPad < 0
    then if 2 < Ypad
	   then begin SetColor(PadClr);
		if 2 < PadSize
		  then begin GotoXY(1, Ypad);
		       write(PadCh);
		       end;
		GotoXY(1, Ypad-1);	   write(PadEndCh);
		GotoXY(1, Ypad+PadSize-2); write(PadEndCh);
		SetColor(EmptyClr);
		GotoXY(1, Ypad + PadSize -1); write(EmptyCh);
		dec(Ypad);
		end
	   else dyPad:= 0
    else if 0 < dyPad
	   then if Ypad + PadSize < Ysize
		  then begin SetColor(PadClr);
		       if 2 < PadSize
			 then begin GotoXY(1, Ypad+PadSize-1);
			      write(PadCh);
			      end;
		       GotoXY(1, Ypad+1);	write(PadEndCh);
		       GotoXY(1, Ypad+PadSize); write(PadEndCh);
		       SetColor(EmptyClr);
		       GotoXY(1, Ypad); write(EmptyCh);
		       inc(Ypad);
		       end
		  else dyPad:= 0;;
  end { MovePad };

  procedure TestKeyBoard;
    (*) var ch: char;(*)
  begin
  if Speed <= Wait then Wait:= 0;
  if pSpeed <= pWait then pWait:= 0;
  while not KeyPressed and (Wait < Speed) do
    begin delay(1); Inc(Wait); Inc(pWait);
    if pSpeed < pWait
      then begin pWait:= 0;					  {$ifdef Demo}
	   if (dxBall < 0) and (Xb < WallXbeg)
	     then dyPad:= YB - (Ypad + PadSize div 2)
	     else dyPad:= 0;
	   pSpeed:= PadSpeed;					       {$endif}
	   MovePad;
	   end;
    end { while };

  if Wait = Speed then MoveBall;

  {$ifdef Demo}

  if (dxBall < 0) and (Xb < WallXbeg)
    then dyPad:= YB - (Ypad + PadSize div 2)
    else dyPad:= 0;
  pSpeed:= PadSpeed;
  if dyPad <> 0 then MovePad;

  {$endif}

  if KeyPressed
    then begin
	 (*)begin ch:= ReadKey;
	 if ch in [LeftKey, RightKey, UpKey, DownKey, ESCkey]
	   then
	 {*) case ReadKey of
	   ESCkey: begin crash:= true; (* give up *)
		   score:= 0; Nballs:= 1;
		   end;
	   #0: {*}
	       case (*)ch{*)ReadKey {*}of
		 (*)
		 ESCkey:   begin crash:= true; { give up }
			   score:= 0; Nballs:= 1;
			   end;
		 (*)
		 UpKey:    begin dyPad:= -1; pspeed:= PadSpeed; end;

		 LeftKey:  begin dyPad:= -1; pspeed:= MaxSpeed-1; end;

		 DownKey:  begin dyPad:= 1; pspeed:= PadSpeed; end;

		 RightKey: begin dyPad:= 1; pspeed:= MaxSpeed-1; end;

		 end { case }
	   else dyPad:= 0;
	   end; { case }
	 MovePad;
	 end;
  end; { TestKeyBoard }

  procedure InitPadBall;
    var i: integer;
  begin
  Ypad:= EntryY - PadSize div 2;
  Xball:= EntryX * 10; YBall:= EntryY * 10;
  Xb:= EntryX; Yb:= EntryY;
  dXball:= -10; dyball:= 0;
  dyPad:= 0;
  {$ifdef Demo}
    Speed:= MaxSpeed;
  {$else}
    Speed:= MinSpeed;
  {$endif}

  SetColor(PadClr);
  GotoXY(1, Ypad); write(PadEndCh);
  for i:= 1 to PadSize-2 do
    begin GotoXY(1, Ypad + i);
    write(PadCh);
    end { for };
  GotoXY(1, Ypad+PadSize-1); write(PadEndCh);

  SetColor(BallClr);
  GotoXY(Xball div 10, Yball div 10);
  write(BallCh);
  end; { InitPadBall }

  procedure ClearPadBall;
    var i: integer;
  begin
  SetColor(EmptyClr);
  for i:= 0 to PadSize-1 do
    begin GotoXY(1, Ypad + i);
    write(EmptyCh);
    end { for };

  GotoXY(Xb, Yb);
  write(EmptyCh);
  end; { ClearPadBall }

  procedure PlayLevel;
    var ch: char;
  begin { PlayLevel }

  NoErrors:= true; DrawBoard;

  repeat InitPadBall; WriteStatus;
    {$ifdef Demo}
      GotoXY(16, 24); SetColor(NormalText); ClrEol;
      write('');
    {$else}
      GotoXY(15, 25); SetColor(NormalText); ClrEol;
      write('   ਣ⢥   ');
      while KeyPressed do if readkey = #0 then ;
      ch:= readkey;
      if (ch = ESCkey) (*){*) or (ch = #0) and (ReadKey = #0){*}
	then begin Nballs:= 0; score:= 0; (*) return {*) exit {*}; end;
      GotoXY(18, 24);
      if PlayerName <> ''
	then write(PlayerName, '': 13 - length(PlayerName))
	else write('. ');
    {$endif}
      GotoXY(9, 25); write(HS[1].score: 5);
      if HS[1].score <> 0
	then begin write('  ');
	     if HS[1].Name <> ''
	       then write(HS[1].Name)
	       else write('. ');
	     end;
      clreol;

    Crash:= false; Wait:= 0; pWait:= 0;
    repeat TestKeyboard;
    until Crash or (Nbricks = 0);
    ClearPadBall;
    if Crash
      then begin { ? }
	   dec(Nballs);
	   NoErrors:= false;
	   end;
    WriteStatus;
  until (Nballs = 0) or (Nbricks = 0);
  if Nbricks = 0
    then begin inc(Score, (1000*ord(NoErrors)) * LevelNo);	 { give BONUS }
	 inc(Nballs);
	 end;
  end; { PlayLevel }

  function NoMore: boolean;
    var ch: char;
  begin
  Title; ShowTop; DoubleLine;
  if Position <> 0
    then begin (*){*)CRT.{*}GotoXY(3, 6 + Position); write('>>'); end;

  GotoXY(1, 24);
  {$ifdef Demo}
    write('᪠  ? '#8#8);
  {$else}
    write(' ࠥ  ? a'#8#8);
  {$endif}
  while keypressed do if readkey = #0 then; { clear keyboard }

  (*){*)Cursor(true); {*} ch:= readkey; (*){*)Cursor(false); {*}
  (*){*) if (ch = #0) and (ReadKey = #0) then ; {*}

  if ch in ['N', 'n', '', '', 'H', 'h', '', '', ESCkey]
    then begin write(#13); clreol;				 {$ifNdef Demo}
	 write(' 类  ᪠   ࠥ? '#8#8);
	 (*){*)Cursor(true); {*} ch:= readkey; (*){*)Cursor(false); {*}
	 (*){*) if (ch = #0) and (ReadKey = #0) then ch:= ''; {*}
	 if not (ch in ['N', 'n', '', '', 'H', 'h', '', '', ESCkey])
	   then begin write(#13); clreol; GetName; end; 	       {$endif}
	 end;
  NoMore:= ch in ['N', 'n', '', '', 'H', 'h', '', '', ESCkey];

  write(#13); clreol;
  end; { NoMore }

  procedure InsertHighScore;
    var i: integer;
	NEWman: HighScore;
	f: file;
	w1, w2, w3, w4: cardinal;
	bap: ^ba;
  begin
  Position:= 0;
  if HS[16].Score < Score
    then begin NEWman.Score:= Score;
	 NEWman.name:= PlayerName;
	 NEWman.Level:= LevelNo;
	 GetDate(w1, w2, w3 (*){*), w4 {*});
	 NEWman.Date:= ((w1 - 1980) * 16 + w2) * 32 + w3;
	 GetTime(w1, w2, w3, w4);
	 NEWman.Time:= w1 * 60 + w2;
	 NEWman.rnd1:= random(65535); NEWman.rnd2:= random(65535);
	 NEWman.rnd3:= random(65535); NEWman.rnd4:= random(65535);
	 NEWman.rnd5:= random(65535); NEWman.rnd6:= random(65535);
	 NEWman.CheckSum:= 0;

	 w1:= 0; bap:= addr(NEWman);
	 for i:= 0 to SizeOf(NEWman)-1 do inc(w1, bap^[i]);

	 NEWman.CheckSum:= w1;

	 ReadHighScores;
	 i:= 16;
	 while (HS[i].Score < Score) and (0 < i)  do dec(i);
	 inc(i);
	 if i < 17
	   then begin (*) MoveWords(HS[i], HS[i+1], WordSizeOf(HS[1])*(16-i));
		{*) Move(HS[i], HS[i+1], SizeOf(HS[i])*(16-i)); {*}
		HS[i]:= NEWman;
		(*) rewrite(f, HghScrName);
		{*) Fsplit(SYSTEM.ParamStr(0), p50, n50, e50);
		    (*$ifdef IN_IDE*) p50:= ''; (*$endif*)
		    assign(f, p50+HghScrName); rewrite(f, 1); {*}
		BlockWrite(f, HS, SizeOf(HS));
		close(f);
		if IOresult = 0 then Position:= i;
		end;
	 end;
  end; { InsertHighScore }

  procedure Initialize;
  begin
  (*)TextMode(Co40);{*) Cursor(false); CheckBreak:= false; TextCo40; {*}
  SetColor(NormalText);
  Title; HasntHigh:= true; ReadHighScores;
  ShowTop; DoubleLine; GetName;

  {$ifNdef UniPas}
  if not_40
    then begin EmptyCh:= '  '; WallCh:= '';
	 BrickCh:= '';
	 BallCh:= '()';
	 end;
  {$endif}

  randomize;
  end; { Initialize }

begin { The Bricks in The Wall }
Initialize;
repeat LevelNo:= 0; Nballs:= StartBalls; Score:= 0;
  PntsPerWall:= 1; PadSize:= MaxPadSz;
  repeat inc(LevelNo);
    PlayLevel;
    if PadSize > MinPadSz
      then begin inc(PntsPerWall); dec(PadSize); end;
  until Nballs = 0;						  {$ifdef Demo}
  Position:= 0; 							{$else}
  InsertHighScore;						       {$endif}
until NoMore;
(*) {*) ReturnMode; NormVideo; Cursor(true); {*}
end  { The Bricks in The Wall }.
